<?php
/**
 * This project has been generated by nuts generator
 * nuts has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 */


namespace Base;

use Provider\Response\Results;
use Slim\Http\Request;
use Slim\Http\Response;
use Symfony\Component\Console\Exception\RuntimeException;


class BaseController
{
	protected $baseModel = "";
	protected $baseHelper = "";
	protected $model;
	protected $helper;
	protected $response;

	public function __construct()
	{
		if ($this->baseModel == "") {
			throw new RuntimeException("Model isnot Intialized");
		}
		$this->model = new $this->baseModel();
		$this->helper = new $this->baseHelper();
		$this->response = new Results();
	}

	public function index(Request $request, Response $response, $args)
	{
		$data = $this->model->getData();
		return $this->response->success($response, $data);
	}

	public function paging(Request $request, Response $response, $args)
	{
		$input = $request->getParsedBody();
		$data = $this->helper->paging($input["data"]);
		return $this->response->success($response, $data);
	}

	public function show(Request $request, Response $response, $args)
	{
		$data = $this->helper->show($args["id"]);
		return $this->response->success($response, $data);
	}

	public function update(Request $request, Response $response, $args)
	{
		$input = $request->getParsedBody();
		$data = $this->helper->update($args["id"], $input["data"]);
		return $this->response->success($response, $data);
	}

	public function delete(Request $request, Response $response, $args)
	{
		$data = $this->helper->delete($args["id"]);
		return $this->response->success($response, $data);
	}

	public function store(Request $request, Response $response, $args)
	{
		$input = $request->getParsedBody();
		$data = $this->helper->store($input["data"]);
		return $this->response->success($response, $data);
	}


}